/*
/* get_fname.c copyright (c) 1996 Clemson University, all rights reserved.
	This program is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License as published
	by the Free Software Foundation; either version 2 of the License, or
	any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of 
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
	General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
	Contact:  Rob Ross  	rbross@parl.eng.clemson.edu
				 Matt Cettei mcettei@parl.eng.clemson.edu

/*/

/*
 * $Log: get_dmeta.c,v $
 * Revision 1.6  1998/02/16 20:28:30  rbross
 * repatched to work with libc5
 *
 * Revision 1.5  1998/02/16 19:23:11  rbross
 * Newt patches
 *
 * Revision 1.4  1997/10/28 19:07:11  pvfs
 * added_license
 *
 * Revision 1.3  1997/07/07 17:00:13  walt
 * fixed numerous bugs to get libc running
 *
 * Revision 1.2  1997/06/26 22:22:04  walt
 * fixed problem getting dmeta for a directory
 *
 * Revision 1.1  1997/06/10 17:52:18  walt
 * Initial revision
 *
 * Revision 1.1  1997/06/04 14:12:08  walt
 * Initial revision
 *
 * Revision 1.1  1997/01/16 16:33:57  mcettei
 * Initial revision
 *
 *
/*/

static char get_dmeta_c[] = "$Header: /projects/pvfs/pvfs-working/mgr/meta/RCS/get_dmeta.c,v 1.6 1998/02/16 20:28:30 rbross Exp $";
/* The get_fname function will take the file name from the request, */
/* read the .pvfsdir file, and return the full file name from the    */
/* mgr's viewpoint - WBL */

#include <errno.h>
#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/file.h>
#include <linux/types.h>
#include <syscall.h>
#include <fcntl.h>
#include <unistd.h>
#include <string.h>
#include <meta.h>

#ifndef SYS_stat
#define SYS_stat (SYS_prev_stat)
#endif

/* GLOBALS */
extern int errno;

int get_dmeta(char * fname, dmeta_p dir, char *temp) {
int i, length, dlength, fd;
struct stat foo;

   /* build name of dotfile */
   strcpy(temp, fname);
   length = strlen(temp);
   if (length == 0) {
      /* this should never happen */
      strcat(temp, ".");
   }
   if ((i = syscall(SYS_stat, temp, &foo)) < 0) {
      /* file doesn't exist - need to fool S_ISDIR */
      foo.st_mode = 0;
   }
   if (!S_ISDIR(foo.st_mode)) {
      while (length >= 0 && temp[length] != '/') {
         temp[length] = 0;
         length--;
      }
   }
   else {
      strcat(temp, "/");
   }
   /* open dotfile */
   strcat(temp, ".pvfsdir");
   if ((fd = syscall(SYS_open, temp, O_RDONLY)) < 1) {
      perror("Error opening dot file");
      return(-1);
   }
   /* find size of dotfile */
   if ((dlength = syscall(SYS_lseek, fd, 0, SEEK_END)) < 0) {
      perror("Error seeking to end of dotfile");
      syscall(SYS_close, fd);
      return(-1);
   }
   if ((i = syscall(SYS_lseek, fd, 0, SEEK_SET)) < 0) {
      perror("Error seeking to start of dotfile");
      syscall(SYS_close, fd);
      return(-1);
   }
   /* read dotfile */
   if ((i = syscall(SYS_read, fd, temp, dlength)) < 0) {
      perror("Error reading dotfile");
      syscall(SYS_close, fd);
      return(-1);
   }
   /* parse dotfile */
   dir->fs_ino = strtol(strtok(temp,"\n"),NULL,10);
   dir->dr_uid = strtol(strtok(NULL,"\n"),NULL,10);
   dir->dr_gid = strtol(strtok(NULL,"\n"),NULL,10);
   dir->dr_mode = strtol(strtok(NULL,"\n"),NULL,8);
   dir->port = strtol(strtok(NULL,"\n"),NULL,10);
   dir->host = strtok(NULL,"\n");
   dir->rd_path = strtok(NULL,"\n");
   dir->sd_path = strtok(NULL,"\n");
   dir->fname = dir->sd_path+strlen(dir->sd_path)+1;
   *(dir->fname) = '\0';
   /* copy file name */
   if (!S_ISDIR(foo.st_mode)) {
      strcat(dir->fname, fname+length+1);
   }
   /* close dotfile */
   syscall(SYS_close, fd);
   /* return data */
   return 0;
}

